%
% Status : main Dynare file
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

if isoctave || matlab_ver_less_than('8.6')
    clear all
else
    clearvars -global
    clear_persistent_variables(fileparts(which('dynare')), false)
end
tic0 = tic;
% Save empty dates and dseries objects in memory.
dates('initialize');
dseries('initialize');
% Define global variables.
global M_ options_ oo_ estim_params_ bayestopt_ dataset_ dataset_info estimation_info ys0_ ex0_
options_ = [];
M_.fname = 'NK_soe';
M_.dynare_version = '4.5.7';
oo_.dynare_version = '4.5.7';
options_.dynare_version = '4.5.7';
%
% Some global variables initialization
%
global_initialization;
diary off;
diary('NK_soe.log');
M_.exo_names = 'e_CG';
M_.exo_names_tex = 'e\_CG';
M_.exo_names_long = 'e_CG';
M_.exo_names = char(M_.exo_names, 'e_IG');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_IG');
M_.exo_names_long = char(M_.exo_names_long, 'e_IG');
M_.exo_names = char(M_.exo_names, 'e_subI');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_subI');
M_.exo_names_long = char(M_.exo_names_long, 'e_subI');
M_.exo_names = char(M_.exo_names, 'e_subL');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_subL');
M_.exo_names_long = char(M_.exo_names_long, 'e_subL');
M_.exo_names = char(M_.exo_names, 'e_tauC');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_tauC');
M_.exo_names_long = char(M_.exo_names_long, 'e_tauC');
M_.exo_names = char(M_.exo_names, 'e_tauW');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_tauW');
M_.exo_names_long = char(M_.exo_names_long, 'e_tauW');
M_.exo_names = char(M_.exo_names, 'e_tauF');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_tauF');
M_.exo_names_long = char(M_.exo_names_long, 'e_tauF');
M_.exo_names = char(M_.exo_names, 'e_tauprof');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_tauprof');
M_.exo_names_long = char(M_.exo_names_long, 'e_tauprof');
M_.exo_names = char(M_.exo_names, 'e_tauK');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_tauK');
M_.exo_names_long = char(M_.exo_names_long, 'e_tauK');
M_.exo_names = char(M_.exo_names, 'e_tauR');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_tauR');
M_.exo_names_long = char(M_.exo_names_long, 'e_tauR');
M_.exo_names = char(M_.exo_names, 'e_tauLC');
M_.exo_names_tex = char(M_.exo_names_tex, 'e\_tauLC');
M_.exo_names_long = char(M_.exo_names_long, 'e_tauLC');
M_.endo_names = 'Cons';
M_.endo_names_tex = '{C}';
M_.endo_names_long = 'Cons';
M_.endo_names = char(M_.endo_names, 'ConsU');
M_.endo_names_tex = char(M_.endo_names_tex, '{C^U}');
M_.endo_names_long = char(M_.endo_names_long, 'ConsU');
M_.endo_names = char(M_.endo_names, 'ConsUtilde');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tilde{C}^U}');
M_.endo_names_long = char(M_.endo_names_long, 'ConsUtilde');
M_.endo_names = char(M_.endo_names, 'ConsC');
M_.endo_names_tex = char(M_.endo_names_tex, '{C^C}');
M_.endo_names_long = char(M_.endo_names_long, 'ConsC');
M_.endo_names = char(M_.endo_names, 'ConsCtilde');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tilde{C}^C}');
M_.endo_names_long = char(M_.endo_names_long, 'ConsCtilde');
M_.endo_names = char(M_.endo_names, 'MU_Cons');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tilde{\lambda}P^C/(1-\tau^W)}');
M_.endo_names_long = char(M_.endo_names_long, 'MU_Cons');
M_.endo_names = char(M_.endo_names, 'i');
M_.endo_names_tex = char(M_.endo_names_tex, '{i}');
M_.endo_names_long = char(M_.endo_names_long, 'i');
M_.endo_names = char(M_.endo_names, 'iW');
M_.endo_names_tex = char(M_.endo_names_tex, '{i^W}');
M_.endo_names_long = char(M_.endo_names_long, 'iW');
M_.endo_names = char(M_.endo_names, 'r');
M_.endo_names_tex = char(M_.endo_names_tex, '{r}');
M_.endo_names_long = char(M_.endo_names_long, 'r');
M_.endo_names = char(M_.endo_names, 'W');
M_.endo_names_tex = char(M_.endo_names_tex, '{W}');
M_.endo_names_long = char(M_.endo_names_long, 'W');
M_.endo_names = char(M_.endo_names, 'Wstar');
M_.endo_names_tex = char(M_.endo_names_tex, '{W^*}');
M_.endo_names_long = char(M_.endo_names_long, 'Wstar');
M_.endo_names = char(M_.endo_names, 'WF');
M_.endo_names_tex = char(M_.endo_names_tex, '{W^F}');
M_.endo_names_long = char(M_.endo_names_long, 'WF');
M_.endo_names = char(M_.endo_names, 'WW');
M_.endo_names_tex = char(M_.endo_names_tex, '{W^W}');
M_.endo_names_long = char(M_.endo_names_long, 'WW');
M_.endo_names = char(M_.endo_names, 'PK');
M_.endo_names_tex = char(M_.endo_names_tex, '{P^K}');
M_.endo_names_long = char(M_.endo_names_long, 'PK');
M_.endo_names = char(M_.endo_names, 'PF');
M_.endo_names_tex = char(M_.endo_names_tex, '{P^F}');
M_.endo_names_long = char(M_.endo_names_long, 'PF');
M_.endo_names = char(M_.endo_names, 'Ph');
M_.endo_names_tex = char(M_.endo_names_tex, '{P}');
M_.endo_names_long = char(M_.endo_names_long, 'Ph');
M_.endo_names = char(M_.endo_names, 'Phstar');
M_.endo_names_tex = char(M_.endo_names_tex, '{P^*}');
M_.endo_names_long = char(M_.endo_names_long, 'Phstar');
M_.endo_names = char(M_.endo_names, 'MC');
M_.endo_names_tex = char(M_.endo_names_tex, '{MC}');
M_.endo_names_long = char(M_.endo_names_long, 'MC');
M_.endo_names = char(M_.endo_names, 'x1');
M_.endo_names_tex = char(M_.endo_names_tex, '{\Phi^1}');
M_.endo_names_long = char(M_.endo_names_long, 'x1');
M_.endo_names = char(M_.endo_names, 'x2');
M_.endo_names_tex = char(M_.endo_names_tex, '{\Phi^2}');
M_.endo_names_long = char(M_.endo_names_long, 'x2');
M_.endo_names = char(M_.endo_names, 'xW1');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tilde{\Lambda}^1}');
M_.endo_names_long = char(M_.endo_names_long, 'xW1');
M_.endo_names = char(M_.endo_names, 'xW2');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tilde{\Lambda}^2}');
M_.endo_names_long = char(M_.endo_names_long, 'xW2');
M_.endo_names = char(M_.endo_names, 'LS');
M_.endo_names_tex = char(M_.endo_names_tex, '{\hat{L}}');
M_.endo_names_long = char(M_.endo_names_long, 'LS');
M_.endo_names = char(M_.endo_names, 'LStilde');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tilde{L}}');
M_.endo_names_long = char(M_.endo_names_long, 'LStilde');
M_.endo_names = char(M_.endo_names, 'LShat');
M_.endo_names_tex = char(M_.endo_names_tex, '{L}');
M_.endo_names_long = char(M_.endo_names_long, 'LShat');
M_.endo_names = char(M_.endo_names, 'Delta');
M_.endo_names_tex = char(M_.endo_names_tex, '{\Delta}');
M_.endo_names_long = char(M_.endo_names_long, 'Delta');
M_.endo_names = char(M_.endo_names, 'Lambda');
M_.endo_names_tex = char(M_.endo_names_tex, '{\Lambda}');
M_.endo_names_long = char(M_.endo_names_long, 'Lambda');
M_.endo_names = char(M_.endo_names, 'H');
M_.endo_names_tex = char(M_.endo_names_tex, '{H}');
M_.endo_names_long = char(M_.endo_names_long, 'H');
M_.endo_names = char(M_.endo_names, 'A');
M_.endo_names_tex = char(M_.endo_names_tex, '{A}');
M_.endo_names_long = char(M_.endo_names_long, 'A');
M_.endo_names = char(M_.endo_names, 'Sav');
M_.endo_names_tex = char(M_.endo_names_tex, '{Sav}');
M_.endo_names_long = char(M_.endo_names_long, 'Sav');
M_.endo_names = char(M_.endo_names, 'vp');
M_.endo_names_tex = char(M_.endo_names_tex, '{v}');
M_.endo_names_long = char(M_.endo_names_long, 'vp');
M_.endo_names = char(M_.endo_names, 'vw');
M_.endo_names_tex = char(M_.endo_names_tex, '{v^w}');
M_.endo_names_long = char(M_.endo_names_long, 'vw');
M_.endo_names = char(M_.endo_names, 'TFP');
M_.endo_names_tex = char(M_.endo_names_tex, '{\Phi}');
M_.endo_names_long = char(M_.endo_names_long, 'TFP');
M_.endo_names = char(M_.endo_names, 'KG');
M_.endo_names_tex = char(M_.endo_names_tex, '{K^G}');
M_.endo_names_long = char(M_.endo_names_long, 'KG');
M_.endo_names = char(M_.endo_names, 'Y');
M_.endo_names_tex = char(M_.endo_names_tex, '{Y}');
M_.endo_names_long = char(M_.endo_names_long, 'Y');
M_.endo_names = char(M_.endo_names, 'Inv');
M_.endo_names_tex = char(M_.endo_names_tex, '{I}');
M_.endo_names_long = char(M_.endo_names_long, 'Inv');
M_.endo_names = char(M_.endo_names, 'J');
M_.endo_names_tex = char(M_.endo_names_tex, '{J}');
M_.endo_names_long = char(M_.endo_names_long, 'J');
M_.endo_names = char(M_.endo_names, 'J_I');
M_.endo_names_tex = char(M_.endo_names_tex, '{J_I}');
M_.endo_names_long = char(M_.endo_names_long, 'J_I');
M_.endo_names = char(M_.endo_names, 'J_K');
M_.endo_names_tex = char(M_.endo_names_tex, '{J_K}');
M_.endo_names_long = char(M_.endo_names_long, 'J_K');
M_.endo_names = char(M_.endo_names, 'K');
M_.endo_names_tex = char(M_.endo_names_tex, '{K}');
M_.endo_names_long = char(M_.endo_names_long, 'K');
M_.endo_names = char(M_.endo_names, 'Khat');
M_.endo_names_tex = char(M_.endo_names_tex, '{\hat{K}}');
M_.endo_names_long = char(M_.endo_names_long, 'Khat');
M_.endo_names = char(M_.endo_names, 'o');
M_.endo_names_tex = char(M_.endo_names_tex, '{o}');
M_.endo_names_long = char(M_.endo_names_long, 'o');
M_.endo_names = char(M_.endo_names, 'delta');
M_.endo_names_tex = char(M_.endo_names_tex, '{\delta}');
M_.endo_names_long = char(M_.endo_names_long, 'delta');
M_.endo_names = char(M_.endo_names, 'q');
M_.endo_names_tex = char(M_.endo_names_tex, '{q}');
M_.endo_names_long = char(M_.endo_names_long, 'q');
M_.endo_names = char(M_.endo_names, 'tauL');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^L}');
M_.endo_names_long = char(M_.endo_names_long, 'tauL');
M_.endo_names = char(M_.endo_names, 'PB');
M_.endo_names_tex = char(M_.endo_names_tex, '{PB}');
M_.endo_names_long = char(M_.endo_names_long, 'PB');
M_.endo_names = char(M_.endo_names, 'VA');
M_.endo_names_tex = char(M_.endo_names_tex, '{\hat{Y}}');
M_.endo_names_long = char(M_.endo_names_long, 'VA');
M_.endo_names = char(M_.endo_names, 'GDP');
M_.endo_names_tex = char(M_.endo_names_tex, '{GDP}');
M_.endo_names_long = char(M_.endo_names_long, 'GDP');
M_.endo_names = char(M_.endo_names, 'GDPr');
M_.endo_names_tex = char(M_.endo_names_tex, '{GDP^r}');
M_.endo_names_long = char(M_.endo_names_long, 'GDPr');
M_.endo_names = char(M_.endo_names, 'E');
M_.endo_names_tex = char(M_.endo_names_tex, '{E}');
M_.endo_names_long = char(M_.endo_names_long, 'E');
M_.endo_names = char(M_.endo_names, 'TB');
M_.endo_names_tex = char(M_.endo_names_tex, '{TB}');
M_.endo_names_long = char(M_.endo_names_long, 'TB');
M_.endo_names = char(M_.endo_names, 'DF');
M_.endo_names_tex = char(M_.endo_names_tex, '{D^F}');
M_.endo_names_long = char(M_.endo_names_long, 'DF');
M_.endo_names = char(M_.endo_names, 'CG');
M_.endo_names_tex = char(M_.endo_names_tex, '{C^G}');
M_.endo_names_long = char(M_.endo_names_long, 'CG');
M_.endo_names = char(M_.endo_names, 'IG');
M_.endo_names_tex = char(M_.endo_names_tex, '{I^G}');
M_.endo_names_long = char(M_.endo_names_long, 'IG');
M_.endo_names = char(M_.endo_names, 'subI');
M_.endo_names_tex = char(M_.endo_names_tex, '{sub^I}');
M_.endo_names_long = char(M_.endo_names_long, 'subI');
M_.endo_names = char(M_.endo_names, 'subL');
M_.endo_names_tex = char(M_.endo_names_tex, '{sub^L}');
M_.endo_names_long = char(M_.endo_names_long, 'subL');
M_.endo_names = char(M_.endo_names, 'tauC');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^C}');
M_.endo_names_long = char(M_.endo_names_long, 'tauC');
M_.endo_names = char(M_.endo_names, 'tauW');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^W}');
M_.endo_names_long = char(M_.endo_names_long, 'tauW');
M_.endo_names = char(M_.endo_names, 'tauF');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^F}');
M_.endo_names_long = char(M_.endo_names_long, 'tauF');
M_.endo_names = char(M_.endo_names, 'tauprof');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^{prof}}');
M_.endo_names_long = char(M_.endo_names_long, 'tauprof');
M_.endo_names = char(M_.endo_names, 'tauK');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^K}');
M_.endo_names_long = char(M_.endo_names_long, 'tauK');
M_.endo_names = char(M_.endo_names, 'tauR');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^R}');
M_.endo_names_long = char(M_.endo_names_long, 'tauR');
M_.endo_names = char(M_.endo_names, 'tauLC');
M_.endo_names_tex = char(M_.endo_names_tex, '{\tau^{LC}}');
M_.endo_names_long = char(M_.endo_names_long, 'tauLC');
M_.endo_names = char(M_.endo_names, 'PCh');
M_.endo_names_tex = char(M_.endo_names_tex, 'PCh');
M_.endo_names_long = char(M_.endo_names_long, 'PCh');
M_.endo_names = char(M_.endo_names, 'PCm');
M_.endo_names_tex = char(M_.endo_names_tex, 'PCm');
M_.endo_names_long = char(M_.endo_names_long, 'PCm');
M_.endo_names = char(M_.endo_names, 'PC');
M_.endo_names_tex = char(M_.endo_names_tex, 'PC');
M_.endo_names_long = char(M_.endo_names_long, 'PC');
M_.endo_names = char(M_.endo_names, 'Consm');
M_.endo_names_tex = char(M_.endo_names_tex, 'Consm');
M_.endo_names_long = char(M_.endo_names_long, 'Consm');
M_.endo_names = char(M_.endo_names, 'Consh');
M_.endo_names_tex = char(M_.endo_names_tex, 'Consh');
M_.endo_names_long = char(M_.endo_names_long, 'Consh');
M_.endo_names = char(M_.endo_names, 'PCtilde');
M_.endo_names_tex = char(M_.endo_names_tex, 'PCtilde');
M_.endo_names_long = char(M_.endo_names_long, 'PCtilde');
M_.endo_names = char(M_.endo_names, 'PInvh');
M_.endo_names_tex = char(M_.endo_names_tex, 'PInvh');
M_.endo_names_long = char(M_.endo_names_long, 'PInvh');
M_.endo_names = char(M_.endo_names, 'PInvm');
M_.endo_names_tex = char(M_.endo_names_tex, 'PInvm');
M_.endo_names_long = char(M_.endo_names_long, 'PInvm');
M_.endo_names = char(M_.endo_names, 'PInv');
M_.endo_names_tex = char(M_.endo_names_tex, 'PInv');
M_.endo_names_long = char(M_.endo_names_long, 'PInv');
M_.endo_names = char(M_.endo_names, 'Invm');
M_.endo_names_tex = char(M_.endo_names_tex, 'Invm');
M_.endo_names_long = char(M_.endo_names_long, 'Invm');
M_.endo_names = char(M_.endo_names, 'Invh');
M_.endo_names_tex = char(M_.endo_names_tex, 'Invh');
M_.endo_names_long = char(M_.endo_names_long, 'Invh');
M_.endo_names = char(M_.endo_names, 'PGh');
M_.endo_names_tex = char(M_.endo_names_tex, 'PGh');
M_.endo_names_long = char(M_.endo_names_long, 'PGh');
M_.endo_names = char(M_.endo_names, 'PGm');
M_.endo_names_tex = char(M_.endo_names_tex, 'PGm');
M_.endo_names_long = char(M_.endo_names_long, 'PGm');
M_.endo_names = char(M_.endo_names, 'PG');
M_.endo_names_tex = char(M_.endo_names_tex, 'PG');
M_.endo_names_long = char(M_.endo_names_long, 'PG');
M_.endo_names = char(M_.endo_names, 'CGm');
M_.endo_names_tex = char(M_.endo_names_tex, 'CGm');
M_.endo_names_long = char(M_.endo_names_long, 'CGm');
M_.endo_names = char(M_.endo_names, 'CGh');
M_.endo_names_tex = char(M_.endo_names_tex, 'CGh');
M_.endo_names_long = char(M_.endo_names_long, 'CGh');
M_.endo_names = char(M_.endo_names, 'PIGh');
M_.endo_names_tex = char(M_.endo_names_tex, 'PIGh');
M_.endo_names_long = char(M_.endo_names_long, 'PIGh');
M_.endo_names = char(M_.endo_names, 'PIGm');
M_.endo_names_tex = char(M_.endo_names_tex, 'PIGm');
M_.endo_names_long = char(M_.endo_names_long, 'PIGm');
M_.endo_names = char(M_.endo_names, 'PIG');
M_.endo_names_tex = char(M_.endo_names_tex, 'PIG');
M_.endo_names_long = char(M_.endo_names_long, 'PIG');
M_.endo_names = char(M_.endo_names, 'IGm');
M_.endo_names_tex = char(M_.endo_names_tex, 'IGm');
M_.endo_names_long = char(M_.endo_names_long, 'IGm');
M_.endo_names = char(M_.endo_names, 'IGh');
M_.endo_names_tex = char(M_.endo_names_tex, 'IGh');
M_.endo_names_long = char(M_.endo_names_long, 'IGh');
M_.endo_partitions = struct();
M_.param_names = 'alpha';
M_.param_names_tex = '{\alpha}';
M_.param_names_long = 'alpha';
M_.param_names = char(M_.param_names, 'sigmaP');
M_.param_names_tex = char(M_.param_names_tex, '{\sigma^P}');
M_.param_names_long = char(M_.param_names_long, 'sigmaP');
M_.param_names = char(M_.param_names, 'sigC');
M_.param_names_tex = char(M_.param_names_tex, '{1/\sigma}');
M_.param_names_long = char(M_.param_names_long, 'sigC');
M_.param_names = char(M_.param_names, 'delta_0');
M_.param_names_tex = char(M_.param_names_tex, '{\delta_0}');
M_.param_names_long = char(M_.param_names_long, 'delta_0');
M_.param_names = char(M_.param_names, 'delta_1');
M_.param_names_tex = char(M_.param_names_tex, '{\delta_1}');
M_.param_names_long = char(M_.param_names_long, 'delta_1');
M_.param_names = char(M_.param_names, 'delta_2');
M_.param_names_tex = char(M_.param_names_tex, '{\delta_2}');
M_.param_names_long = char(M_.param_names_long, 'delta_2');
M_.param_names = char(M_.param_names, 'rho');
M_.param_names_tex = char(M_.param_names_tex, '{\beta-1}/\beta');
M_.param_names_long = char(M_.param_names_long, 'rho');
M_.param_names = char(M_.param_names, 'thetaL');
M_.param_names_tex = char(M_.param_names_tex, '{\eta}');
M_.param_names_long = char(M_.param_names_long, 'thetaL');
M_.param_names = char(M_.param_names, 'Psi');
M_.param_names_tex = char(M_.param_names_tex, '{\psi}');
M_.param_names_long = char(M_.param_names_long, 'Psi');
M_.param_names = char(M_.param_names, 'sigell');
M_.param_names_tex = char(M_.param_names_tex, '{1/\sigma^F}');
M_.param_names_long = char(M_.param_names_long, 'sigell');
M_.param_names = char(M_.param_names, 'epsilon');
M_.param_names_tex = char(M_.param_names_tex, '{\epsion}');
M_.param_names_long = char(M_.param_names_long, 'epsilon');
M_.param_names = char(M_.param_names, 'epsilonW');
M_.param_names_tex = char(M_.param_names_tex, '{\epsilon^w}');
M_.param_names_long = char(M_.param_names_long, 'epsilonW');
M_.param_names = char(M_.param_names, 'phi');
M_.param_names_tex = char(M_.param_names_tex, '{\theta}');
M_.param_names_long = char(M_.param_names_long, 'phi');
M_.param_names = char(M_.param_names, 'phiW');
M_.param_names_tex = char(M_.param_names_tex, '{\theta^w}');
M_.param_names_long = char(M_.param_names_long, 'phiW');
M_.param_names = char(M_.param_names, 'rho_eps');
M_.param_names_tex = char(M_.param_names_tex, '{\rho^\epsilon}');
M_.param_names_long = char(M_.param_names_long, 'rho_eps');
M_.param_names = char(M_.param_names, 'parhabit');
M_.param_names_tex = char(M_.param_names_tex, '{\kappa}');
M_.param_names_long = char(M_.param_names_long, 'parhabit');
M_.param_names = char(M_.param_names, 'parhabitL');
M_.param_names_tex = char(M_.param_names_tex, '{\kappa^L}');
M_.param_names_long = char(M_.param_names_long, 'parhabitL');
M_.param_names = char(M_.param_names, 'FC');
M_.param_names_tex = char(M_.param_names_tex, '{FC}');
M_.param_names_long = char(M_.param_names_long, 'FC');
M_.param_names = char(M_.param_names, 'unconst');
M_.param_names_tex = char(M_.param_names_tex, '{\pi}');
M_.param_names_long = char(M_.param_names_long, 'unconst');
M_.param_names = char(M_.param_names, 'A_0');
M_.param_names_tex = char(M_.param_names_tex, '{A^0}');
M_.param_names_long = char(M_.param_names_long, 'A_0');
M_.param_names = char(M_.param_names, 'epsG');
M_.param_names_tex = char(M_.param_names_tex, '{\sigma^G}');
M_.param_names_long = char(M_.param_names_long, 'epsG');
M_.param_names = char(M_.param_names, 'deltaG');
M_.param_names_tex = char(M_.param_names_tex, '{\delta^G}');
M_.param_names_long = char(M_.param_names_long, 'deltaG');
M_.param_names = char(M_.param_names, 'gam');
M_.param_names_tex = char(M_.param_names_tex, '{\gamma}');
M_.param_names_long = char(M_.param_names_long, 'gam');
M_.param_names = char(M_.param_names, 'xiCm');
M_.param_names_tex = char(M_.param_names_tex, '{\xi^C}');
M_.param_names_long = char(M_.param_names_long, 'xiCm');
M_.param_names = char(M_.param_names, 'sigCm');
M_.param_names_tex = char(M_.param_names_tex, '{\lambda^C}');
M_.param_names_long = char(M_.param_names_long, 'sigCm');
M_.param_names = char(M_.param_names, 'xiIm');
M_.param_names_tex = char(M_.param_names_tex, '{\xi^I}');
M_.param_names_long = char(M_.param_names_long, 'xiIm');
M_.param_names = char(M_.param_names, 'sigIm');
M_.param_names_tex = char(M_.param_names_tex, '{\lambda^I}');
M_.param_names_long = char(M_.param_names_long, 'sigIm');
M_.param_names = char(M_.param_names, 'xiGm');
M_.param_names_tex = char(M_.param_names_tex, '{\xi^{C^G}}');
M_.param_names_long = char(M_.param_names_long, 'xiGm');
M_.param_names = char(M_.param_names, 'sigGm');
M_.param_names_tex = char(M_.param_names_tex, '{\lambda^{C^G}}');
M_.param_names_long = char(M_.param_names_long, 'sigGm');
M_.param_names = char(M_.param_names, 'xiIGm');
M_.param_names_tex = char(M_.param_names_tex, '{\xi^{I^G}}');
M_.param_names_long = char(M_.param_names_long, 'xiIGm');
M_.param_names = char(M_.param_names, 'sigIGm');
M_.param_names_tex = char(M_.param_names_tex, '{\lambda^{I^G}}');
M_.param_names_long = char(M_.param_names_long, 'sigIGm');
M_.param_names = char(M_.param_names, 'Pm');
M_.param_names_tex = char(M_.param_names_tex, '{P^m}');
M_.param_names_long = char(M_.param_names_long, 'Pm');
M_.param_names = char(M_.param_names, 'E_0');
M_.param_names_tex = char(M_.param_names_tex, '{E^0}');
M_.param_names_long = char(M_.param_names_long, 'E_0');
M_.param_names = char(M_.param_names, 'sigExport');
M_.param_names_tex = char(M_.param_names_tex, '{-\lambda^E}');
M_.param_names_long = char(M_.param_names_long, 'sigExport');
M_.param_names = char(M_.param_names, 'risk');
M_.param_names_tex = char(M_.param_names_tex, '{-\psi^{DF}}');
M_.param_names_long = char(M_.param_names_long, 'risk');
M_.param_names = char(M_.param_names, 'i0');
M_.param_names_tex = char(M_.param_names_tex, '{i^*}');
M_.param_names_long = char(M_.param_names_long, 'i0');
M_.param_names = char(M_.param_names, 'DGr0');
M_.param_names_tex = char(M_.param_names_tex, '{D^{G,r}_0}');
M_.param_names_long = char(M_.param_names_long, 'DGr0');
M_.param_names = char(M_.param_names, 'Ph0');
M_.param_names_tex = char(M_.param_names_tex, 'Ph0');
M_.param_names_long = char(M_.param_names_long, 'Ph0');
M_.param_names = char(M_.param_names, 'PC0');
M_.param_names_tex = char(M_.param_names_tex, 'PC0');
M_.param_names_long = char(M_.param_names_long, 'PC0');
M_.param_names = char(M_.param_names, 'PInv0');
M_.param_names_tex = char(M_.param_names_tex, 'PInv0');
M_.param_names_long = char(M_.param_names_long, 'PInv0');
M_.param_names = char(M_.param_names, 'PG0');
M_.param_names_tex = char(M_.param_names_tex, 'PG0');
M_.param_names_long = char(M_.param_names_long, 'PG0');
M_.param_names = char(M_.param_names, 'PIG0');
M_.param_names_tex = char(M_.param_names_tex, 'PIG0');
M_.param_names_long = char(M_.param_names_long, 'PIG0');
M_.param_names = char(M_.param_names, 'DF0');
M_.param_names_tex = char(M_.param_names_tex, 'DF0');
M_.param_names_long = char(M_.param_names_long, 'DF0');
M_.param_names = char(M_.param_names, 'VA0');
M_.param_names_tex = char(M_.param_names_tex, 'VA0');
M_.param_names_long = char(M_.param_names_long, 'VA0');
M_.param_names = char(M_.param_names, 'CG0');
M_.param_names_tex = char(M_.param_names_tex, 'CG0');
M_.param_names_long = char(M_.param_names_long, 'CG0');
M_.param_names = char(M_.param_names, 'IG0');
M_.param_names_tex = char(M_.param_names_tex, 'IG0');
M_.param_names_long = char(M_.param_names_long, 'IG0');
M_.param_names = char(M_.param_names, 'subI0');
M_.param_names_tex = char(M_.param_names_tex, 'subI0');
M_.param_names_long = char(M_.param_names_long, 'subI0');
M_.param_names = char(M_.param_names, 'subL0');
M_.param_names_tex = char(M_.param_names_tex, 'subL0');
M_.param_names_long = char(M_.param_names_long, 'subL0');
M_.param_names = char(M_.param_names, 'tauC0');
M_.param_names_tex = char(M_.param_names_tex, 'tauC0');
M_.param_names_long = char(M_.param_names_long, 'tauC0');
M_.param_names = char(M_.param_names, 'tauF0');
M_.param_names_tex = char(M_.param_names_tex, 'tauF0');
M_.param_names_long = char(M_.param_names_long, 'tauF0');
M_.param_names = char(M_.param_names, 'tauK0');
M_.param_names_tex = char(M_.param_names_tex, 'tauK0');
M_.param_names_long = char(M_.param_names_long, 'tauK0');
M_.param_names = char(M_.param_names, 'tauLC0');
M_.param_names_tex = char(M_.param_names_tex, 'tauLC0');
M_.param_names_long = char(M_.param_names_long, 'tauLC0');
M_.param_names = char(M_.param_names, 'tauR0');
M_.param_names_tex = char(M_.param_names_tex, 'tauR0');
M_.param_names_long = char(M_.param_names_long, 'tauR0');
M_.param_names = char(M_.param_names, 'tauW0');
M_.param_names_tex = char(M_.param_names_tex, 'tauW0');
M_.param_names_long = char(M_.param_names_long, 'tauW0');
M_.param_names = char(M_.param_names, 'tauprof0');
M_.param_names_tex = char(M_.param_names_tex, 'tauprof0');
M_.param_names_long = char(M_.param_names_long, 'tauprof0');
M_.param_names = char(M_.param_names, 'PB0');
M_.param_names_tex = char(M_.param_names_tex, 'PB0');
M_.param_names_long = char(M_.param_names_long, 'PB0');
M_.param_names = char(M_.param_names, 'TaxCbase0');
M_.param_names_tex = char(M_.param_names_tex, 'TaxCbase0');
M_.param_names_long = char(M_.param_names_long, 'TaxCbase0');
M_.param_names = char(M_.param_names, 'TaxWbase0');
M_.param_names_tex = char(M_.param_names_tex, 'TaxWbase0');
M_.param_names_long = char(M_.param_names_long, 'TaxWbase0');
M_.param_names = char(M_.param_names, 'TaxFbase0');
M_.param_names_tex = char(M_.param_names_tex, 'TaxFbase0');
M_.param_names_long = char(M_.param_names_long, 'TaxFbase0');
M_.param_names = char(M_.param_names, 'Taxprofbase0');
M_.param_names_tex = char(M_.param_names_tex, 'Taxprofbase0');
M_.param_names_long = char(M_.param_names_long, 'Taxprofbase0');
M_.param_names = char(M_.param_names, 'TaxKbase0');
M_.param_names_tex = char(M_.param_names_tex, 'TaxKbase0');
M_.param_names_long = char(M_.param_names_long, 'TaxKbase0');
M_.param_names = char(M_.param_names, 'TaxRbase0');
M_.param_names_tex = char(M_.param_names_tex, 'TaxRbase0');
M_.param_names_long = char(M_.param_names_long, 'TaxRbase0');
M_.param_names = char(M_.param_names, 'Inv0');
M_.param_names_tex = char(M_.param_names_tex, 'Inv0');
M_.param_names_long = char(M_.param_names_long, 'Inv0');
M_.param_partitions = struct();
M_.exo_det_nbr = 0;
M_.exo_nbr = 11;
M_.endo_nbr = 84;
M_.param_nbr = 63;
M_.orig_endo_nbr = 84;
M_.aux_vars = [];
M_.predetermined_variables = [ 7 8 9 34 40 52 ];
M_.Sigma_e = zeros(11, 11);
M_.Correlation_matrix = eye(11, 11);
M_.H = 0;
M_.Correlation_matrix_ME = 1;
M_.sigma_e_is_diagonal = 1;
M_.det_shocks = [];
options_.block=0;
options_.bytecode=0;
options_.use_dll=0;
M_.hessian_eq_zero = 1;
erase_compiled_function('NK_soe_static');
erase_compiled_function('NK_soe_dynamic');
M_.orig_eq_nbr = 84;
M_.eq_nbr = 84;
M_.ramsey_eq_nbr = 0;
M_.set_auxiliary_variables = exist(['./' M_.fname '_set_auxiliary_variables.m'], 'file') == 2;
M_.lead_lag_incidence = [
 0 22 0;
 1 23 0;
 0 24 0;
 2 25 0;
 0 26 0;
 0 27 0;
 0 28 0;
 0 29 0;
 0 30 0;
 3 31 0;
 0 32 0;
 0 33 0;
 0 34 0;
 0 35 0;
 0 36 0;
 4 37 106;
 0 38 0;
 0 39 0;
 0 40 107;
 0 41 108;
 0 42 109;
 0 43 110;
 0 44 0;
 0 45 0;
 5 46 0;
 0 47 111;
 0 48 112;
 0 49 113;
 0 50 114;
 0 51 0;
 6 52 0;
 7 53 0;
 0 54 0;
 8 55 0;
 0 56 0;
 0 57 0;
 0 58 0;
 0 59 0;
 0 60 0;
 9 61 0;
 0 62 0;
 0 63 0;
 0 64 0;
 0 65 115;
 0 66 0;
 0 67 0;
 0 68 0;
 0 69 0;
 0 70 0;
 0 71 0;
 0 72 0;
 10 73 0;
 11 74 0;
 12 75 0;
 13 76 0;
 14 77 0;
 15 78 0;
 16 79 0;
 17 80 0;
 18 81 0;
 19 82 0;
 20 83 0;
 21 84 0;
 0 85 0;
 0 86 0;
 0 87 0;
 0 88 0;
 0 89 0;
 0 90 0;
 0 91 0;
 0 92 0;
 0 93 0;
 0 94 0;
 0 95 0;
 0 96 0;
 0 97 0;
 0 98 0;
 0 99 0;
 0 100 0;
 0 101 0;
 0 102 0;
 0 103 0;
 0 104 0;
 0 105 0;]';
M_.nstatic = 54;
M_.nfwrd   = 9;
M_.npred   = 20;
M_.nboth   = 1;
M_.nsfwrd   = 10;
M_.nspred   = 21;
M_.ndynamic   = 30;
M_.equations_tags = {
};
M_.static_and_dynamic_models_differ = 0;
M_.exo_names_orig_ord = [1:11];
M_.maximum_lag = 1;
M_.maximum_lead = 1;
M_.maximum_endo_lag = 1;
M_.maximum_endo_lead = 1;
oo_.steady_state = zeros(84, 1);
M_.maximum_exo_lag = 0;
M_.maximum_exo_lead = 0;
oo_.exo_steady_state = zeros(11, 1);
M_.params = NaN(63, 1);
M_.NNZDerivatives = [353; 0; -1];
close all;
shock_size      = 0.001;
shocktype = 1;
instrumentname = "CG";
M_.params( 23 ) = param_gam;
gam = M_.params( 23 );
M_.params( 1 ) = param_alpha;
alpha = M_.params( 1 );
M_.params( 3 ) = param_sigC;
sigC = M_.params( 3 );
M_.params( 4 ) = param_delta_0;
delta_0 = M_.params( 4 );
M_.params( 5 ) = param_delta_1;
delta_1 = M_.params( 5 );
M_.params( 6 ) = param_delta_2;
delta_2 = M_.params( 6 );
M_.params( 7 ) = param_rho;
rho = M_.params( 7 );
M_.params( 8 ) = param_thetaL;
thetaL = M_.params( 8 );
M_.params( 9 ) = param_Psi;
Psi = M_.params( 9 );
M_.params( 10 ) = param_sigell;
sigell = M_.params( 10 );
M_.params( 11 ) = param_epsilon;
epsilon = M_.params( 11 );
M_.params( 12 ) = param_epsilonW;
epsilonW = M_.params( 12 );
M_.params( 13 ) = param_phi;
phi = M_.params( 13 );
M_.params( 14 ) = param_phiW;
phiW = M_.params( 14 );
M_.params( 18 ) = param_FC0;
FC = M_.params( 18 );
M_.params( 16 ) = param_parhabit;
parhabit = M_.params( 16 );
M_.params( 17 ) = param_parhabitL;
parhabitL = M_.params( 17 );
M_.params( 22 ) = param_deltaG;
deltaG = M_.params( 22 );
M_.params( 20 ) = param_A_0;
A_0 = M_.params( 20 );
M_.params( 21 ) = param_epsG;
epsG = M_.params( 21 );
M_.params( 2 ) = param_sigmaP;
sigmaP = M_.params( 2 );
M_.params( 19 ) = param_unconst;
unconst = M_.params( 19 );
M_.params( 47 ) = ss_subI0;
subI0 = M_.params( 47 );
M_.params( 48 ) = ss_subL0;
subL0 = M_.params( 48 );
M_.params( 49 ) = ss_tauC0;
tauC0 = M_.params( 49 );
M_.params( 50 ) = ss_tauF0;
tauF0 = M_.params( 50 );
M_.params( 51 ) = ss_tauK0;
tauK0 = M_.params( 51 );
M_.params( 52 ) = ss_tauLC0;
tauLC0 = M_.params( 52 );
M_.params( 53 ) = ss_tauR0;
tauR0 = M_.params( 53 );
M_.params( 54 ) = ss_tauW0;
tauW0 = M_.params( 54 );
M_.params( 55 ) = ss_tauprof0;
tauprof0 = M_.params( 55 );
M_.params( 56 ) = ss_PB0;
PB0 = M_.params( 56 );
M_.params( 37 ) = ss_DGr0;
DGr0 = M_.params( 37 );
M_.params( 45 ) = ss_CG0;
CG0 = M_.params( 45 );
M_.params( 46 ) = ss_IG0;
IG0 = M_.params( 46 );
M_.params( 57 ) = ss_TaxCbase0;
TaxCbase0 = M_.params( 57 );
M_.params( 58 ) = ss_TaxWbase0;
TaxWbase0 = M_.params( 58 );
M_.params( 59 ) = ss_TaxFbase0;
TaxFbase0 = M_.params( 59 );
M_.params( 60 ) = ss_Taxprofbase0;
Taxprofbase0 = M_.params( 60 );
M_.params( 61 ) = ss_TaxKbase0;
TaxKbase0 = M_.params( 61 );
M_.params( 62 ) = ss_TaxRbase0;
TaxRbase0 = M_.params( 62 );
M_.params( 63 ) = ss_Inv0;
Inv0 = M_.params( 63 );
M_.params( 38 ) = ss_Ph0;
Ph0 = M_.params( 38 );
M_.params( 32 ) = ss_Pm0;
Pm = M_.params( 32 );
M_.params( 39 ) = ss_PC0;
PC0 = M_.params( 39 );
M_.params( 41 ) = ss_PG0;
PG0 = M_.params( 41 );
M_.params( 40 ) = ss_PInv0;
PInv0 = M_.params( 40 );
M_.params( 42 ) = ss_PIG0;
PIG0 = M_.params( 42 );
M_.params( 24 ) = param_xiCm;
xiCm = M_.params( 24 );
M_.params( 25 ) = param_sigCm;
sigCm = M_.params( 25 );
M_.params( 26 ) = param_xiIm;
xiIm = M_.params( 26 );
M_.params( 27 ) = param_sigIm;
sigIm = M_.params( 27 );
M_.params( 28 ) = param_xiGm;
xiGm = M_.params( 28 );
M_.params( 29 ) = param_sigGm;
sigGm = M_.params( 29 );
M_.params( 30 ) = param_xiIGm;
xiIGm = M_.params( 30 );
M_.params( 31 ) = param_sigIGm;
sigIGm = M_.params( 31 );
M_.params( 43 ) = ss_DF0;
DF0 = M_.params( 43 );
M_.params( 44 ) = ss_VA0;
VA0 = M_.params( 44 );
M_.params( 33 ) = param_E_0;
E_0 = M_.params( 33 );
M_.params( 34 ) = param_sigExport;
sigExport = M_.params( 34 );
M_.params( 35 ) = param_risk;
risk = M_.params( 35 );
M_.params( 36 ) = ss_i0;
i0 = M_.params( 36 );
M_.params( 15 ) = 0.7;
rho_eps = M_.params( 15 );
%
% INITVAL instructions
%
options_.initval_file = 0;
oo_.steady_state( 9 ) = param_r0;
oo_.steady_state( 7 ) = ss_i0;
oo_.steady_state( 8 ) = ss_iW0;
oo_.steady_state( 16 ) = ss_Ph0;
oo_.steady_state( 66 ) = ss_PC0;
oo_.steady_state( 10 ) = ss_W0;
oo_.steady_state( 11 ) = ss_Wstar0;
oo_.steady_state( 12 ) = ss_WF0;
oo_.steady_state( 13 ) = ss_WW0;
oo_.steady_state( 23 ) = ss_LS0;
oo_.steady_state( 24 ) = ss_LStilde0;
oo_.steady_state( 25 ) = ss_LShat0;
oo_.steady_state( 26 ) = ss_Delta0;
oo_.steady_state( 27 ) = ss_Lambda0;
oo_.steady_state( 28 ) = ss_H0;
oo_.steady_state( 2 ) = ss_ConsU0;
oo_.steady_state( 3 ) = ss_ConsUtilde0;
oo_.steady_state( 4 ) = ss_ConsC0;
oo_.steady_state( 5 ) = ss_ConsCtilde0;
oo_.steady_state( 1 ) = ss_Cons0;
oo_.steady_state( 6 ) = ss_MU_Cons0;
oo_.steady_state( 18 ) = ss_MC0;
oo_.steady_state( 35 ) = ss_Y0;
oo_.steady_state( 31 ) = ss_vp0;
oo_.steady_state( 32 ) = ss_vw0;
oo_.steady_state( 17 ) = ss_Phstar0;
oo_.steady_state( 19 ) = ss_x10;
oo_.steady_state( 20 ) = ss_x20;
oo_.steady_state( 21 ) = ss_xW10;
oo_.steady_state( 22 ) = ss_xW20;
oo_.steady_state( 34 ) = ss_KG0;
oo_.steady_state( 33 ) = ss_TFP0;
oo_.steady_state( 36 ) = ss_Inv0;
oo_.steady_state( 40 ) = ss_K0;
oo_.steady_state( 41 ) = ss_Khat0;
oo_.steady_state( 42 ) = ss_o0;
oo_.steady_state( 43 ) = ss_delta0;
oo_.steady_state( 37 ) = 0;
oo_.steady_state( 38 ) = 0;
oo_.steady_state( 39 ) = 0;
oo_.steady_state( 14 ) = ss_PK0;
oo_.steady_state( 15 ) = ss_PF0;
oo_.steady_state( 44 ) = ss_q0;
oo_.steady_state( 45 ) = ss_tauL0;
oo_.steady_state( 29 ) = ss_A0;
oo_.steady_state( 30 ) = ss_Sav0;
oo_.steady_state( 52 ) = ss_DF0;
oo_.steady_state( 50 ) = ss_E0;
oo_.steady_state( 51 ) = ss_TB0;
oo_.steady_state( 47 ) = ss_VA0;
oo_.steady_state( 46 ) = ss_PB0;
oo_.steady_state( 48 ) = ss_GDP0;
oo_.steady_state( 49 ) = ss_GDPr0;
oo_.steady_state( 53 ) = ss_CG0;
oo_.steady_state( 54 ) = ss_IG0;
oo_.steady_state( 55 ) = ss_subI0;
oo_.steady_state( 56 ) = ss_subL0;
oo_.steady_state( 57 ) = ss_tauC0;
oo_.steady_state( 58 ) = ss_tauW0;
oo_.steady_state( 59 ) = ss_tauF0;
oo_.steady_state( 60 ) = ss_tauprof0;
oo_.steady_state( 61 ) = ss_tauK0;
oo_.steady_state( 62 ) = ss_tauR0;
oo_.steady_state( 63 ) = ss_tauLC0;
oo_.steady_state( 66 ) = ss_PC0;
oo_.steady_state( 65 ) = ss_PCm0;
oo_.steady_state( 64 ) = ss_PCh0;
oo_.steady_state( 67 ) = ss_Consm0;
oo_.steady_state( 68 ) = ss_Consh0;
oo_.steady_state( 69 ) = ss_PCtilde0;
oo_.steady_state( 72 ) = ss_PInv0;
oo_.steady_state( 71 ) = ss_PInvm0;
oo_.steady_state( 70 ) = ss_PInvh0;
oo_.steady_state( 74 ) = ss_Invh0;
oo_.steady_state( 73 ) = ss_Invm0;
oo_.steady_state( 77 ) = ss_PG0;
oo_.steady_state( 76 ) = ss_PGm0;
oo_.steady_state( 75 ) = ss_PGh0;
oo_.steady_state( 78 ) = ss_CGm0;
oo_.steady_state( 79 ) = ss_CGh0;
oo_.steady_state( 82 ) = ss_PIG0;
oo_.steady_state( 80 ) = ss_PIGh0;
oo_.steady_state( 81 ) = ss_PIGm0;
oo_.steady_state( 83 ) = ss_IGm0;
oo_.steady_state( 84 ) = ss_IGh0;
if M_.exo_nbr > 0
	oo_.exo_simul = ones(M_.maximum_lag,1)*oo_.exo_steady_state';
end
if M_.exo_det_nbr > 0
	oo_.exo_det_simul = ones(M_.maximum_lag,1)*oo_.exo_det_steady_state';
end
steady;
oo_.dr.eigval = check(M_,options_,oo_);
%
% ENDVAL instructions
%
ys0_= oo_.steady_state;
ex0_ = oo_.exo_steady_state;
oo_.steady_state( 9 ) = param_r0;
oo_.steady_state( 7 ) = ss_i0;
oo_.steady_state( 8 ) = ss_iW0;
oo_.steady_state( 16 ) = ss_Ph0;
oo_.steady_state( 66 ) = ss_PC0;
oo_.steady_state( 10 ) = ss_W0;
oo_.steady_state( 11 ) = ss_Wstar0;
oo_.steady_state( 12 ) = ss_WF0;
oo_.steady_state( 13 ) = ss_WW0;
oo_.steady_state( 23 ) = ss_LS0;
oo_.steady_state( 24 ) = ss_LStilde0;
oo_.steady_state( 25 ) = ss_LShat0;
oo_.steady_state( 26 ) = ss_Delta0;
oo_.steady_state( 27 ) = ss_Lambda0;
oo_.steady_state( 28 ) = ss_H0;
oo_.steady_state( 2 ) = ss_ConsU0;
oo_.steady_state( 3 ) = ss_ConsUtilde0;
oo_.steady_state( 4 ) = ss_ConsC0;
oo_.steady_state( 5 ) = ss_ConsCtilde0;
oo_.steady_state( 1 ) = ss_Cons0;
oo_.steady_state( 6 ) = ss_MU_Cons0;
oo_.steady_state( 18 ) = ss_MC0;
oo_.steady_state( 35 ) = ss_Y0;
oo_.steady_state( 31 ) = ss_vp0;
oo_.steady_state( 32 ) = ss_vw0;
oo_.steady_state( 17 ) = ss_Phstar0;
oo_.steady_state( 19 ) = ss_x10;
oo_.steady_state( 20 ) = ss_x20;
oo_.steady_state( 21 ) = ss_xW10;
oo_.steady_state( 22 ) = ss_xW20;
oo_.steady_state( 34 ) = ss_KG0;
oo_.steady_state( 33 ) = ss_TFP0;
oo_.steady_state( 36 ) = ss_Inv0;
oo_.steady_state( 40 ) = ss_K0;
oo_.steady_state( 41 ) = ss_Khat0;
oo_.steady_state( 42 ) = ss_o0;
oo_.steady_state( 43 ) = ss_delta0;
oo_.steady_state( 37 ) = 0;
oo_.steady_state( 38 ) = 0;
oo_.steady_state( 39 ) = 0;
oo_.steady_state( 14 ) = ss_PK0;
oo_.steady_state( 15 ) = ss_PF0;
oo_.steady_state( 44 ) = ss_q0;
oo_.steady_state( 45 ) = ss_tauL0;
oo_.steady_state( 29 ) = ss_A0;
oo_.steady_state( 30 ) = ss_Sav0;
oo_.steady_state( 52 ) = ss_DF0;
oo_.steady_state( 50 ) = ss_E0;
oo_.steady_state( 51 ) = ss_TB0;
oo_.steady_state( 47 ) = ss_VA0;
oo_.steady_state( 46 ) = ss_PB0;
oo_.steady_state( 48 ) = ss_GDP0;
oo_.steady_state( 49 ) = ss_GDPr0;
oo_.steady_state( 53 ) = ss_CG0;
oo_.steady_state( 54 ) = ss_IG0;
oo_.steady_state( 55 ) = ss_subI0;
oo_.steady_state( 56 ) = ss_subL0;
oo_.steady_state( 57 ) = ss_tauC0;
oo_.steady_state( 58 ) = ss_tauW0;
oo_.steady_state( 59 ) = ss_tauF0;
oo_.steady_state( 60 ) = ss_tauprof0;
oo_.steady_state( 61 ) = ss_tauK0;
oo_.steady_state( 62 ) = ss_tauR0;
oo_.steady_state( 63 ) = ss_tauLC0;
oo_.steady_state( 66 ) = ss_PC0;
oo_.steady_state( 65 ) = ss_PCm0;
oo_.steady_state( 64 ) = ss_PCh0;
oo_.steady_state( 67 ) = ss_Consm0;
oo_.steady_state( 68 ) = ss_Consh0;
oo_.steady_state( 69 ) = ss_PCtilde0;
oo_.steady_state( 72 ) = ss_PInv0;
oo_.steady_state( 71 ) = ss_PInvm0;
oo_.steady_state( 70 ) = ss_PInvh0;
oo_.steady_state( 74 ) = ss_Invh0;
oo_.steady_state( 73 ) = ss_Invm0;
oo_.steady_state( 77 ) = ss_PG0;
oo_.steady_state( 76 ) = ss_PGm0;
oo_.steady_state( 75 ) = ss_PGh0;
oo_.steady_state( 78 ) = ss_CGm0;
oo_.steady_state( 79 ) = ss_CGh0;
oo_.steady_state( 82 ) = ss_PIG0;
oo_.steady_state( 80 ) = ss_PIGh0;
oo_.steady_state( 81 ) = ss_PIGm0;
oo_.steady_state( 83 ) = ss_IGm0;
oo_.steady_state( 84 ) = ss_IGh0;
oo_.exo_steady_state( 1 ) = shock_size;
M_.params( 15 ) = 0.0;
rho_eps = M_.params( 15 );
steady;
options_.dynatol.f = 1e-10;
options_.dynatol.x = 1e-10;
options_.periods = 500;
perfect_foresight_setup;
perfect_foresight_solver;
if ((shocktype == 1)||(shocktype == 2))
Y0 = ss_Y0;
GDPr0 = ss_GDPr0;
tend = length(Y);
if (shocktype == 1)
shock = [0; ones(tend-1,1)]*shock_size;
else
shock = [0; 1; cumprod(ones(tend-2,1)*rho_eps)]*shock_size;
end;
expostshock = PB0-PB./Ph*Ph0;
discfactor = cumprod(1./(1+[0;0; r(2:end-1)]));
mult = Ph0*(Y-Y0)./shock;
PVmult = cumsum(Ph0*(Y-Y0).*discfactor)./cumsum(shock.*discfactor);
PVmult = PVmult(2:end);
PVmultGDPr = cumsum((GDPr-GDPr0).*discfactor)./cumsum(shock.*discfactor);
PVmultGDPr = PVmultGDPr(2:end);
mult_expost = Ph0*(Y-Y0)./expostshock;
PVmult_expost = cumsum(Ph0*(Y-Y0).*discfactor)./cumsum(expostshock.*discfactor);
PVmult_expost = PVmult_expost(2:end);
PVmultGDPr_expost = cumsum((GDPr-GDPr0).*discfactor)./cumsum(expostshock.*discfactor);
PVmultGDPr_expost = PVmultGDPr_expost(2:end);
else
dY    = eval(join(["Y_e_",instrumentname],""));
dGDPr = eval(join(["GDPr_e_",instrumentname],""));
tend  = length(dY);
shock = [1; cumprod(ones(tend-1,1)*rho_eps)]*shock_size;
dPh    = eval(join(["Ph_e_",instrumentname],""));
dPB    = eval(join(["PB_e_",instrumentname],""));
expostshock = PB0-(PB0+dPB)./(Ph0+dPh)*Ph0;
dr    = eval(join(["r_e_",instrumentname],""));
r0 = param_r0;    
r2 = r0+dr;
discfactor = cumprod(1./(1+[0; r2(2:end)]));
mult = Ph0*dY./shock;
PVmult = cumsum(Ph0*dY.*discfactor)./cumsum(shock.*discfactor);
PVmultGDPr = cumsum(dGDPr.*discfactor)./cumsum(shock.*discfactor);
mult_expost = Ph0*dY./expostshock;
PVmult_expost = cumsum(Ph0*dY.*discfactor)./cumsum(expostshock.*discfactor);
PVmultGDPr_expost = cumsum(dGDPr.*discfactor)./cumsum(expostshock.*discfactor);
end;
figure(10);
hold on;
Plot1 = plot(PVmult(1:40));          Line1 = 'Value added PV multiplier';
Plot2 = plot(PVmultGDPr(1:40));      Line2 = 'real GDP PV multiplier';
Plot3 = plot(PVmult_expost(1:40));   Line3 = 'Value added PV multiplier (ex-post)';
legend([Plot1;Plot2;Plot3], Line1, Line2, Line3);
save('NK_soe_results.mat', 'oo_', 'M_', 'options_');
if exist('estim_params_', 'var') == 1
  save('NK_soe_results.mat', 'estim_params_', '-append');
end
if exist('bayestopt_', 'var') == 1
  save('NK_soe_results.mat', 'bayestopt_', '-append');
end
if exist('dataset_', 'var') == 1
  save('NK_soe_results.mat', 'dataset_', '-append');
end
if exist('estimation_info', 'var') == 1
  save('NK_soe_results.mat', 'estimation_info', '-append');
end
if exist('dataset_info', 'var') == 1
  save('NK_soe_results.mat', 'dataset_info', '-append');
end
if exist('oo_recursive_', 'var') == 1
  save('NK_soe_results.mat', 'oo_recursive_', '-append');
end


disp(['Total computing time : ' dynsec2hms(toc(tic0)) ]);
if ~isempty(lastwarn)
  disp('Note: warning(s) encountered in MATLAB/Octave code')
end
diary off
